/*********************************************************************
 Author:  Ruriko Yoshida
 Data:    November 25th, 2003
 Update:  April 22nd, 2004
 Program: This code defines TreeNodes for the binary tree.

***********************************************************************/

#ifndef MJOIN__H
#define MJOIN__H

#include <iostream.h>
#include <fstream.h>
#include <cstdlib>
#include <cstring>
#include <math.h>
#include <algorithm>
#include <time.h>

#include "Reading.h"

using namespace std;

TreeNode* MJOIN(int argc, char *argv[]);
TreeNode* MJOIN(int & n, int m, char *filename, char* freq, char* TsTv, 
		double &tfreq, double &cfreq, double &afreq, double &gfreq, 
		double trans, Alinements **InputData);
TreeNode* MJOIN(int n, int m, long long int numOfWeights, 
		char** names, long double * totalBrLen);

TreeNode* MJOIN(int & n, int m, char *filename, char* freq, char* TsTv, 
		double &tfreq, double &cfreq, double &afreq, double &gfreq, 
		double trans, Alinements ** InputData, int ***SeqMat, 
		int & SetLen, int numSt);

#endif
