/*********************************************************************
 Author:  Ruriko Yoshida
 Date:    August 7th, 2004
 Update:  August 7th, 2004
  
Comments: Using table class instead of taxa class.
 
***********************************************************************/

#ifndef TREETABLE__H
#define TREETABLE__H

#include <fstream.h>
#include <iostream.h>
#include <cstdlib>
#include <cstring>
#include <math.h>
#include <algorithm>
#include <time.h>

#include "Cherry.h"

double Sum1_Table(int n, int i, Table data);
double Sum2_Table(int n, int i, int j, Table data);
double CherryPicking_Table(int n, int i, int j, Table data, int N);
void findMin2_Table(int n, int & I, int & J, Table data, Table M, int& counter, int* ind, int N);
void UpdateTaxa_Table(int n, int I, int J, Table & data);
void EdgeWts_Table(Table Data, int n, int m, int i, int j, double & wts1, double & wts2, int N);
void CreateTreeMatric_Table(Taxa * Data, int n, int m, Table & S);
void createMatFile(char* filename, char** names, int n, Table S);

#endif
