#include <fstream.h>
#include <iostream.h>
#include <cstdlib>
#include <cstring>
#include <math.h>
#include <algorithm>
#include <time.h>
#include <list.h>

using namespace std;
 
void removeDash(string** InputData, int n){
 
  int max_length = 0; 
  max_length = (*InputData)[0].length(); 
  int counter = 0;
  int Index[max_length];

  for(int i = 0; i < max_length; i++) Index[i] = 0;
   
   //   for(int j = 0; j < n; j++){
   for(int i = 0; i < max_length; i++){
     for(int j = 0; j < n; j++){
       // if((*InputData)[j].DNA[i] == '-')
       if(((*InputData)[j][i] != 'A') && ((*InputData)[j][i] != 'G') && ((*InputData)[j][i] != 'C') && ((*InputData)[j][i] != 'T'))
	 Index[i] = 1; 
     }
   }

   for(int i = 0; i < max_length; i++){
     for(int j = 0; j < n; j++){
       if(Index[i] == 1)
	 (*InputData)[j][i] = '-';
     }
   }

//    for(int i = 0; i < n; i++)
//      cout << (*InputData)[i] << endl;
 }


int** DNAMat(string* InputData, int n, int & max_length){
  int **Mat, numDash = 0, counter = 0; 
  max_length = InputData[0].length(); 

  for(int j = 0; j < max_length; j++)
    if(InputData[0][j] == '-') numDash++;

  Mat = new int*[n];
  for(int i = 0; i < n; i++)
    Mat[i] = new int[max_length - numDash];

  for(int i = 0; i < n; i++){
    counter = 0;
     for(int j = 0; j < max_length; j++){
       if(InputData[i][j] != '-'){
	 if(InputData[i][j] == 'A')
	   Mat[i][counter] = 1;
	 else if(InputData[i][j] == 'G')
	   Mat[i][counter] = 2;
	 else if(InputData[i][j] == 'C')
	   Mat[i][counter] = 3;
	 else if(InputData[i][j] == 'T')
	   Mat[i][counter] = 4;
	 else{
	   cerr << "Sequences contains non A, G, C, T letters!" << endl;
	   cerr << "It contains: " << InputData[i][j] << endl; 
	   exit(0);
	 }
	 counter++;
       }
     }
  }


  max_length -= numDash;

  char DNA[5] = "AGCT";
  //  cout << n << " " << max_length << endl;
  for(int i = 0; i < n; i++){
    // cout << InputData[i].name << " ";
    //for(int j = 0; j < 10; j++) cout << " ";
     for(int j = 0; j < max_length; j++)
       cout << DNA[Mat[i][j]-1];
     cout << endl;
       }
 
//   for(int i = 0; i < n; i++){
//      for(int j = 0; j < max_length; j++)
//        cout << Mat[i][j] << " ";
//      cout << endl;
//        }


  return Mat;
}


int main(int argc, char* argv[]){
  int n, max_length;
  string *dna;
  ifstream in(argv[1]);
  in >> n;
  dna = new string[n];

  for(int i = 0; i < n; i++) in >> dna[i];

  removeDash(&dna, n);
  DNAMat(dna, n, max_length);
  delete [] dna;
  return 0;
}
