/*********************************************************************
 Author:  Ruriko Yoshida
 Date:    June 21st, 2004
 Update:  July 24th, 2005
  
***********************************************************************/
#ifndef CHERRY__H
#define CHERRY__H
 
#include <fstream.h>
#include <iostream.h>
#include <cstdlib>
#include <string>
#include <math.h>
#include <algorithm>
#include <time.h>

#include "Index.h"

using namespace std;

class Table1{
 public:
  int length;
  double * table;
  Table1(int n){
    length = n;
    table = new double[length];
    for(int i = 0; i < length; i++)
      table[i] = 0;
  }
  Table1(){
    ;
  }
  void Assign(int n){
    length = n;
    table = new double[length];
    for(int i = 0; i < length; i++)
      table[i] = 0;
  }
};

class Table{
 public:
  int length;
  Table1 * table;
  Table(int n){
    length = n;
    table = new Table1[length];
    for(int i = 0; i < n; i++){
      table[i].Assign(n);
    }
  }

};

void findMin(int n, int m, int & I, int & J, Taxa * data, Table M);

void findMin2(int n, int m, int & I, int & J, Taxa * data, Table M, int & i, int *ind, int N);

void testTaxa(int n, int m, Taxa * data);

void UpdateTaxa(int n, int m, int I, int J, Taxa * data);

void UpdateTaxa2(int n, int m, int I, int J, Taxa * data);

void setZero(int n, int m, int I, Taxa * data);

void findMin_Original(int n, int & I, int & J, Taxa * data, Table M);

void findMin2_Original(int n, int & I, int & J, Taxa * data, Table M, int & i, int *ind, int N);

void UpdateTaxa_Original(int n, int I, int J, Taxa * data);

double newUpdateTaxa(int N, int M, int I, int J, Taxa * data);

#endif
