/*********************************************************************
 Author:  Ruriko Yoshida
 Date:    February 7th, 2006
 Update:  February 7th, 2006
 Program: This is software for the EMGNJ method with Asger Hobolth.

********************************************************************/

#ifndef JC_TREE__H
#define JC_TREE__H

long double JC_tree(int** SeqMat, int** PhlMat, LaSymmMatDouble RateMat, 
		    LaVectorDouble Frq, LaVectorDouble& BrLen, int numSt, 
		    int numLvs, int numNds, int nIter, int SeqLen);

void runJC_Tree(int nIter, int numLvs, int numSt, int** PhylMat,
		LaVectorDouble BrLenV2, int** SeqMat, int SeqLen);

#endif
